--	  Capturing Deadlock Data
-- ** Demonstrated on SQL Server 2008 R2 10.50.1617 ** --

/*
	Trace flag options (outputs to SQL Error Log):
	
		1204 (older version option)
				
		1222 (available since 2005) - XML-like format with 18 data points not in 1204
*/

-- Method #1, using a Trace flag in the startup options via SSCM

	-- Demo deadlock
	-- SSMS vs. C:\Program Files\Microsoft SQL Server\MSSQL10_50.R22008\MSSQL\Log
	-- Clear out the trace flag

-- Method #2, using DBCC TRACEON

	DBCC TRACEON(1222)
	DBCC TRACESTATUS
	DBCC TRACEOFF(1222)
	
	DBCC TRACEON (1222,-1)
	DBCC TRACESTATUS
	
	-- Demo deadlock
	
	DBCC TRACEOFF (1222,-1)
	DBCC TRACESTATUS

-- Method #3, using SQL Server Profiler

	-- SQL Profiler launch

-- Method #4, using the system health session (available in SQL Server 2008 +)
-- Query is compliments of Jonathan Kehayias and Paul Randal on the below query
-- (Session contains deadlock event info, locks exceeding a set period, latch waits and more)
SELECT CAST (
    REPLACE (
        REPLACE (
            XEventData.XEvent.value ('(data/value)[1]', 'varchar(max)'),
            '<victim-list>', '<deadlock><victim-list>'),
        '<process-list>', '</victim-list><process-list>')
    AS XML) AS DeadlockGraph
FROM (SELECT CAST (target_data AS XML) AS TargetData
    FROM sys.dm_xe_session_targets st
    JOIN sys.dm_xe_sessions s ON s.address = st.event_session_address
    WHERE [name] = 'system_health') AS Data
CROSS APPLY TargetData.nodes ('//RingBufferTarget/event') AS XEventData (XEvent)
    WHERE XEventData.XEvent.value('@name', 'varchar(4000)') = 'xml_deadlock_report';